type ErrorWithCode = Error & {
    code: number;
};
type MaybeErrorWithCode = ErrorWithCode | null | undefined;
export declare class MetadataMintMistmatchError extends Error {
    readonly code: number;
    readonly name: string;
    constructor();
}
export declare class InvalidMetadataError extends Error {
    readonly code: number;
    readonly name: string;
    constructor();
}
export declare class InvalidAuthorityError extends Error {
    readonly code: number;
    readonly name: string;
    constructor();
}
export declare class InvalidStateDerivationError extends Error {
    readonly code: number;
    readonly name: string;
    constructor();
}
export declare class InvalidStateDeserializationError extends Error {
    readonly code: number;
    readonly name: string;
    constructor();
}
export declare class MigrationInProgressError extends Error {
    readonly code: number;
    readonly name: string;
    constructor();
}
export declare class IncorrectProgramOwnerError extends Error {
    readonly code: number;
    readonly name: string;
    constructor();
}
export declare class OverflowError extends Error {
    readonly code: number;
    readonly name: string;
    constructor();
}
export declare class InvalidInstructionError extends Error {
    readonly code: number;
    readonly name: string;
    constructor();
}
export declare class NoRuleSetError extends Error {
    readonly code: number;
    readonly name: string;
    constructor();
}
export declare class InvalidSignerDerivationError extends Error {
    readonly code: number;
    readonly name: string;
    constructor();
}
export declare class AlreadyInitializedError extends Error {
    readonly code: number;
    readonly name: string;
    constructor();
}
export declare class InvalidDelegateError extends Error {
    readonly code: number;
    readonly name: string;
    constructor();
}
export declare class FeatureDisabledError extends Error {
    readonly code: number;
    readonly name: string;
    constructor();
}
export declare function errorFromCode(code: number): MaybeErrorWithCode;
export declare function errorFromName(name: string): MaybeErrorWithCode;
export {};
