"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.errorFromName = exports.errorFromCode = exports.FeatureDisabledError = exports.InvalidDelegateError = exports.AlreadyInitializedError = exports.InvalidSignerDerivationError = exports.NoRuleSetError = exports.InvalidInstructionError = exports.OverflowError = exports.IncorrectProgramOwnerError = exports.MigrationInProgressError = exports.InvalidStateDeserializationError = exports.InvalidStateDerivationError = exports.InvalidAuthorityError = exports.InvalidMetadataError = exports.MetadataMintMistmatchError = void 0;
const createErrorFromCodeLookup = new Map();
const createErrorFromNameLookup = new Map();
class MetadataMintMistmatchError extends Error {
    constructor() {
        super('Metadata does not match mint account');
        this.code = 0x0;
        this.name = 'MetadataMintMistmatch';
        if (typeof Error.captureStackTrace === 'function') {
            Error.captureStackTrace(this, MetadataMintMistmatchError);
        }
    }
}
exports.MetadataMintMistmatchError = MetadataMintMistmatchError;
createErrorFromCodeLookup.set(0x0, () => new MetadataMintMistmatchError());
createErrorFromNameLookup.set('MetadataMintMistmatch', () => new MetadataMintMistmatchError());
class InvalidMetadataError extends Error {
    constructor() {
        super('Metadata did not deserialize correctly');
        this.code = 0x1;
        this.name = 'InvalidMetadata';
        if (typeof Error.captureStackTrace === 'function') {
            Error.captureStackTrace(this, InvalidMetadataError);
        }
    }
}
exports.InvalidMetadataError = InvalidMetadataError;
createErrorFromCodeLookup.set(0x1, () => new InvalidMetadataError());
createErrorFromNameLookup.set('InvalidMetadata', () => new InvalidMetadataError());
class InvalidAuthorityError extends Error {
    constructor() {
        super('Authority does not match the authority on the account');
        this.code = 0x2;
        this.name = 'InvalidAuthority';
        if (typeof Error.captureStackTrace === 'function') {
            Error.captureStackTrace(this, InvalidAuthorityError);
        }
    }
}
exports.InvalidAuthorityError = InvalidAuthorityError;
createErrorFromCodeLookup.set(0x2, () => new InvalidAuthorityError());
createErrorFromNameLookup.set('InvalidAuthority', () => new InvalidAuthorityError());
class InvalidStateDerivationError extends Error {
    constructor() {
        super('Migration state account derivation is in correct');
        this.code = 0x3;
        this.name = 'InvalidStateDerivation';
        if (typeof Error.captureStackTrace === 'function') {
            Error.captureStackTrace(this, InvalidStateDerivationError);
        }
    }
}
exports.InvalidStateDerivationError = InvalidStateDerivationError;
createErrorFromCodeLookup.set(0x3, () => new InvalidStateDerivationError());
createErrorFromNameLookup.set('InvalidStateDerivation', () => new InvalidStateDerivationError());
class InvalidStateDeserializationError extends Error {
    constructor() {
        super('Migration state did not deserialize correctly');
        this.code = 0x4;
        this.name = 'InvalidStateDeserialization';
        if (typeof Error.captureStackTrace === 'function') {
            Error.captureStackTrace(this, InvalidStateDeserializationError);
        }
    }
}
exports.InvalidStateDeserializationError = InvalidStateDeserializationError;
createErrorFromCodeLookup.set(0x4, () => new InvalidStateDeserializationError());
createErrorFromNameLookup.set('InvalidStateDeserialization', () => new InvalidStateDeserializationError());
class MigrationInProgressError extends Error {
    constructor() {
        super('Cannot close while migration is in progress');
        this.code = 0x5;
        this.name = 'MigrationInProgress';
        if (typeof Error.captureStackTrace === 'function') {
            Error.captureStackTrace(this, MigrationInProgressError);
        }
    }
}
exports.MigrationInProgressError = MigrationInProgressError;
createErrorFromCodeLookup.set(0x5, () => new MigrationInProgressError());
createErrorFromNameLookup.set('MigrationInProgress', () => new MigrationInProgressError());
class IncorrectProgramOwnerError extends Error {
    constructor() {
        super('Incorrect program owner for migration state account');
        this.code = 0x6;
        this.name = 'IncorrectProgramOwner';
        if (typeof Error.captureStackTrace === 'function') {
            Error.captureStackTrace(this, IncorrectProgramOwnerError);
        }
    }
}
exports.IncorrectProgramOwnerError = IncorrectProgramOwnerError;
createErrorFromCodeLookup.set(0x6, () => new IncorrectProgramOwnerError());
createErrorFromNameLookup.set('IncorrectProgramOwner', () => new IncorrectProgramOwnerError());
class OverflowError extends Error {
    constructor() {
        super('Overflow error');
        this.code = 0x7;
        this.name = 'Overflow';
        if (typeof Error.captureStackTrace === 'function') {
            Error.captureStackTrace(this, OverflowError);
        }
    }
}
exports.OverflowError = OverflowError;
createErrorFromCodeLookup.set(0x7, () => new OverflowError());
createErrorFromNameLookup.set('Overflow', () => new OverflowError());
class InvalidInstructionError extends Error {
    constructor() {
        super('Failed to build Migrate instruction');
        this.code = 0x8;
        this.name = 'InvalidInstruction';
        if (typeof Error.captureStackTrace === 'function') {
            Error.captureStackTrace(this, InvalidInstructionError);
        }
    }
}
exports.InvalidInstructionError = InvalidInstructionError;
createErrorFromCodeLookup.set(0x8, () => new InvalidInstructionError());
createErrorFromNameLookup.set('InvalidInstruction', () => new InvalidInstructionError());
class NoRuleSetError extends Error {
    constructor() {
        super('No rule set provided');
        this.code = 0x9;
        this.name = 'NoRuleSet';
        if (typeof Error.captureStackTrace === 'function') {
            Error.captureStackTrace(this, NoRuleSetError);
        }
    }
}
exports.NoRuleSetError = NoRuleSetError;
createErrorFromCodeLookup.set(0x9, () => new NoRuleSetError());
createErrorFromNameLookup.set('NoRuleSet', () => new NoRuleSetError());
class InvalidSignerDerivationError extends Error {
    constructor() {
        super('Program signer account derivation is in correct');
        this.code = 0xa;
        this.name = 'InvalidSignerDerivation';
        if (typeof Error.captureStackTrace === 'function') {
            Error.captureStackTrace(this, InvalidSignerDerivationError);
        }
    }
}
exports.InvalidSignerDerivationError = InvalidSignerDerivationError;
createErrorFromCodeLookup.set(0xa, () => new InvalidSignerDerivationError());
createErrorFromNameLookup.set('InvalidSignerDerivation', () => new InvalidSignerDerivationError());
class AlreadyInitializedError extends Error {
    constructor() {
        super('Program signer is already initialized');
        this.code = 0xb;
        this.name = 'AlreadyInitialized';
        if (typeof Error.captureStackTrace === 'function') {
            Error.captureStackTrace(this, AlreadyInitializedError);
        }
    }
}
exports.AlreadyInitializedError = AlreadyInitializedError;
createErrorFromCodeLookup.set(0xb, () => new AlreadyInitializedError());
createErrorFromNameLookup.set('AlreadyInitialized', () => new AlreadyInitializedError());
class InvalidDelegateError extends Error {
    constructor() {
        super('Invalid delegate');
        this.code = 0xc;
        this.name = 'InvalidDelegate';
        if (typeof Error.captureStackTrace === 'function') {
            Error.captureStackTrace(this, InvalidDelegateError);
        }
    }
}
exports.InvalidDelegateError = InvalidDelegateError;
createErrorFromCodeLookup.set(0xc, () => new InvalidDelegateError());
createErrorFromNameLookup.set('InvalidDelegate', () => new InvalidDelegateError());
class FeatureDisabledError extends Error {
    constructor() {
        super('This feature is currently disabled');
        this.code = 0xd;
        this.name = 'FeatureDisabled';
        if (typeof Error.captureStackTrace === 'function') {
            Error.captureStackTrace(this, FeatureDisabledError);
        }
    }
}
exports.FeatureDisabledError = FeatureDisabledError;
createErrorFromCodeLookup.set(0xd, () => new FeatureDisabledError());
createErrorFromNameLookup.set('FeatureDisabled', () => new FeatureDisabledError());
function errorFromCode(code) {
    const createError = createErrorFromCodeLookup.get(code);
    return createError != null ? createError() : null;
}
exports.errorFromCode = errorFromCode;
function errorFromName(name) {
    const createError = createErrorFromNameLookup.get(name);
    return createError != null ? createError() : null;
}
exports.errorFromName = errorFromName;
//# sourceMappingURL=index.js.map